<?php 
function send_file($path) {
	@ob_end_clean(); 
	@ini_set('zlib.output_compression', 'Off');

	header('Pragma: public');
	header('Expires: 0');
	header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	header('Cache-Control: public'); 
	header('Content-Type: application/force-download');
	header('Content-Type: application/octet-stream');
	header('Content-Type: application/download');
	header('Content-Disposition: attachment; filename="' . basename($path) . '";');
	header('Content-Transfer-Encoding: binary');
	header('Content-Length: ' . filesize($path));

	$handle = fopen($path, 'rb');

	do {
		$data = fread($handle, 8192);
		if (strlen($data) == 0) {
			break;
		}
		echo($data);
	} while (true);

	fclose($handle);
	exit();
}

function display_nav($p, $UploadDir) {
	$p_explode = explode('/', $p);
	$i = 0;
	$url = NULL;
	$nav = gettext('location') . ' <a href="./">Home</a> ';
	for($i ; $i < count($p_explode) - 1 ; $i++) {
		$url .= urlencode($p_explode[$i]) . '/';
		$nav .= '> <a href="./?p=' . $url . '">' . $p_explode[$i] . '</a> ';
	}

	if (is_file($UploadDir . $p))
		$nav .= '> <a href="?p=' . urlencode($p) . '">' . $p_explode[$i] . '</a> ';

	return($nav);
}

function SetupLang($lang) {
	setlocale(LC_ALL, $lang);

	$domain = 'messages';
	$localedir = dirname($_SERVER['SCRIPT_FILENAME']) . '/locale';
	bindtextdomain($domain, $localedir); 
	textdomain($domain);
}

function erase_stuff($name) {
	if (is_file($name)) {
		if (@unlink($name))
			$return = true;
		else
			return (false);
	}

	if (is_dir($name)) {
		$dir = dir($name);
		while($entry = $dir->read()) {
			if ($entry != '.' && $entry != '..') {
				if(is_dir($name . '/' . $entry))
					$return = erase_stuff($name . '/' . $entry);
				else
					if (@unlink($name . '/' . $entry))
						$return = true;
					else
						return (false);
			}
		}
		$dir->close();
		if (@rmdir($name))
			$return = true;
		else
			return (false);
	}
	return ($return);
}

function check_root_dir($dir, $p) {
	$root_dir = str_replace('/', '\/', $dir);

	if (!preg_match("/^$root_dir/", $p))
		$p = $dir;

	return ($p);
}
?>
